using System;
using System.Collections.Generic;
using System.Text;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI;
using System.ComponentModel;

namespace VSLiveBoston.WebParts.Common
{
	[ParseChildren(true)]
	[ToolboxData("<{0}:CustomWebPartZone runat='server'></{0}:CustomWebPartZone>")]
	public class CustomWebPartZone : WebPartZone
	{
		public CustomWebPartZone()
		{

		}

		protected override WebPartChrome CreateWebPartChrome()
		{
			return new CustomWebPartChrome(this, this.WebPartManager);
		}

		private string m_layoutTemplate;

		[PersistenceMode(PersistenceMode.InnerProperty)]
		[NotifyParentProperty(true)]
		public string LayoutTemplate
		{
			get
			{
				return m_layoutTemplate;
			}
			set
			{
				m_layoutTemplate = value;
			}
		}

		private string m_layoutVerbTemplate;
		[NotifyParentProperty(true)]
		[PersistenceMode(PersistenceMode.InnerProperty)]
		public string LayoutVerbTemplate
		{
			get
			{
				return m_layoutVerbTemplate;
			}
			set
			{
				m_layoutVerbTemplate = value;
			}
		}

		private bool m_treatCloseAsDelete;
		public bool TreatCloseAsDelete
		{
			get
			{
				return m_treatCloseAsDelete;
			}
			set
			{
				m_treatCloseAsDelete = value;
			}
		}

		protected virtual WebPartVerb FindVerb(string commandName, WebPart part)
		{
			if (part == null)
			{
				return null;
			}
			else
			{
				foreach (WebPartVerb verb in part.Verbs)
				{
					if (verb.ID == commandName)
					{
						return verb;
					}
				}

				return null;
			}
		}

		protected override void RaisePostBackEvent(string eventArgument)
		{
			if (eventArgument != null)
			{
				string[] eventArgTokens = eventArgument.Split(':');

				if (eventArgTokens.Length == 2)
				{
					string webPartName = eventArgTokens[0];

					WebPart part = this.WebParts[webPartName];

					string verbName = eventArgTokens[1];

					if (verbName == this.MinimizeVerb.Text)
					{
						this.MinimizeWebPart(part);
					}
					else if (verbName == this.RestoreVerb.Text)
					{
						this.RestoreWebPart(part);
					}
					else if (verbName == this.CloseVerb.Text)
					{
						if (this.TreatCloseAsDelete == true)
						{
							this.DeleteWebPart(part);
						}
						else
						{
							this.CloseWebPart(part);
						}
					}
					else if (verbName == this.DeleteVerb.Text)
					{
						this.DeleteWebPart(part);
					}
					else
					{
						WebPartVerb verb = FindVerb(eventArgTokens[1], part);

						if (verb != null && part != null)
						{
							verb.ServerClickHandler(verb, new WebPartEventArgs(part));
						}
					}
				}
			}
		}
	}
}
